Use previous version of script

i accidentally committed the wrong version of the diff
Esse commit está contido em:
Paul Tarjan
2013-06-24 14:42:28 -07:00
commit de Sara Golemon
commit cf37a18981
2 arquivos alterados com 85 adições e 17 exclusões
+1 -1
Ver Arquivo
@@ -389,7 +389,7 @@ function run($options, $tests, $bad_test_file) {
function run_test($options, $test) {
$hhvm = hhvm_cmd($options, $test);
$hhvm = __DIR__."/../tools/timeout.sh 60 $hhvm";
$hhvm = __DIR__."/../tools/timeout.sh -t 60 $hhvm";
$output = "";
if (isset($options['repo'])) {
if (strpos($test, '.hhas') !== false ||
+84 -16
Ver Arquivo
@@ -1,23 +1,91 @@
#!/bin/bash
#
# The Bash shell script executes a command with a time-out.
# Upon time-out expiration SIGTERM (15) is sent to the process. If the signal
# is blocked, then the subsequent SIGKILL (9) terminates it.
#
# Based on the Bash documentation example.
timeout=$1
shift
# Hello Chet,
# please find attached a "little easier" :-) to comprehend
# time-out example. If you find it suitable, feel free to include
# anywhere: the very same logic as in the original examples/scripts, a
# little more transparent implementation to my taste.
#
# Dmitry V Golovashkin <Dmitry.Golovashkin@sas.com>
# Start the script that does the real work.
"$@" &
pid=$!
scriptName="${0##*/}"
# Don't let the whole process take longer than 15 seconds, in case
# Phabricator is acting up.
declare -i DEFAULT_TIMEOUT=9
declare -i DEFAULT_INTERVAL=1
declare -i DEFAULT_DELAY=1
# Timeout.
declare -i timeout=DEFAULT_TIMEOUT
# Interval between checks if the process is still alive.
declare -i interval=DEFAULT_INTERVAL
# Delay between posting the SIGTERM signal and destroying the process by SIGKILL.
declare -i delay=DEFAULT_DELAY
function printUsage() {
cat <<EOF
Synopsis
$scriptName [-t timeout] [-i interval] [-d delay] command
Execute a command with a time-out.
Upon time-out expiration SIGTERM (15) is sent to the process. If SIGTERM
signal is blocked, then the subsequent SIGKILL (9) terminates it.
-t timeout
Number of seconds to wait for command completion.
Default value: $DEFAULT_TIMEOUT seconds.
-i interval
Interval between checks if the process is still alive.
Positive integer, default value: $DEFAULT_INTERVAL seconds.
-d delay
Delay between posting the SIGTERM signal and destroying the
process by SIGKILL. Default value: $DEFAULT_DELAY seconds.
As of today, Bash does not support floating point arithmetic (sleep does),
therefore all delay/time values must be integers.
EOF
}
# Options.
while getopts ":t:i:d:" option; do
case "$option" in
t) timeout=$OPTARG ;;
i) interval=$OPTARG ;;
d) delay=$OPTARG ;;
*) printUsage; exit 1 ;;
esac
done
shift $((OPTIND - 1))
# $# should be at least 1 (the command to execute), however it may be strictly
# greater than 1 if the command itself has options.
if (($# == 0 || interval <= 0)); then
printUsage
exit 1
fi
# kill -0 pid Exit code indicates if a signal may be sent to $pid process.
(
sleep $timeout
echo -e "\nTimeout after $timeout seconds, giving up" > /dev/stderr
kill $$
) &
timeout_pid=$!
((t = timeout))
wait $pid 2>/dev/null
status=$?
kill $timeout_pid 2>/dev/null
while ((t > 0)); do
sleep $interval
kill -0 $$ || exit 0
((t -= interval))
done
exit $status
# Be nice, post SIGTERM first.
# The 'exit 0' below will be executed if any preceeding command fails.
kill -s SIGTERM $$ && kill -0 $$ || exit 0
sleep $delay
kill -s SIGKILL $$
) 2> /dev/null &
exec "$@"